snake_init:
	pusha
snake_main_loop:	

	call snake_draw_init

	;; wait for key press
	push ax
	mov ah, 0
	int 0x16
	pop ax

	call snake_propagate

	jmp snake_main_loop					;infinite loop for now!
	
	
snake_exit:
	popa
	ret

snake_draw_init:
	;; clear screen
	mov ah, 0
	mov al, 0x03
	int 0x10

	
	mov bx, 0							;how many elements of the snake?
	mov cl, 0							;snake position buffer
	mov dl, [snake_sprite_head_pos + 1] ;y
	mov dh, [snake_sprite_head_pos]		;x
snake_draw_loop:
	;; if bx is divisible by 4, it means we need to grab the next byte for cx
	push bx

	and bx, 3					;bx % 4

	;; debugging
	;//push ax
	;//mov ax, bx
	;//call print_hex
	;//pop ax

	cmp bx, 0
	
	pop bx
	
	je snake_next_byte

	;; need to shift
	shl cl, 2
snake_draw_loaded:				;bytes are ready to go
	
	cmp bx, [snake_sprite_length]
	jge snake_draw_exit


	mov ah, 0x02
	int 0x10					;set x, y

	mov al, 'O'
	call print_char				;relatively slow

	;;shift left by 6, right by 6 to get the right most bytes
	push cx
	;//shl cl, 6
	shr cl, 6
	;; move cursor position accordingly
	call snake_draw_move_cursor
	pop cx

	inc bx

	jmp snake_draw_loop

snake_next_byte:
	push bx
	shr bx, 2				;divide by 2^2
	
	add bx, snake_sprite
	mov cl, [bx]

	;//	push ax
	;//mov ax, cx
	;//call print_hex
	;//	pop ax
	
	pop bx
	jmp snake_draw_loaded
	
snake_draw_exit:
	ret

	;; cl - lower 2 bits will be compared
snake_draw_move_cursor:
	cmp cl, 0x0					;up
	je snake_draw_move_up

	cmp cl, 0x1					;down
	je snake_draw_move_down

	cmp cl, 0x2					;left
	je snake_draw_move_left

	cmp cl, 0x3					;right
	je snake_draw_move_right

	;; if we get here there was a critical problem
	ret

	;; should probably handle edge cases(screen border)
snake_draw_move_up:
	sub dh, 1
	jmp snake_draw_move_cursor_exit

snake_draw_move_down:
	add dh, 1
	jmp snake_draw_move_cursor_exit

snake_draw_move_left:
	sub dl, 1
	jmp snake_draw_move_cursor_exit

snake_draw_move_right:
	add dl, 1
	jmp snake_draw_move_cursor_exit
	
snake_draw_move_cursor_exit:
	ret

snake_propagate:
	pusha
	;; propagates the snake forward.
	;; TODO: If the dir is opposite to the current head dir, game should end

	;; THIS DOESNT WORK
	;; I do not know why
	;; head_pos does not change
	;; actually I think it does work
	mov dl, [snake_sprite_head_pos + 1] ;y
	mov dh, [snake_sprite_head_pos]		;x
	mov cl, [snake_dir]
	call snake_draw_move_cursor
	mov [snake_sprite_head_pos + 1], dl
	mov [snake_sprite_head_pos], dh ;can be combined into a single statement

	mov dx, 0		   ;2byte counter
	;; 1. shift snake_sprite to the right by 2 bits
	mov bx, snake_sprite
snake_propagate_loop:


	mov ax, word [bx]				;we can process 2 bytes at once o:
	xchg al, ah						;stupid endianness
	;; one value stored in cl(more recent), one in ch(older)
	mov cl, al					;cx will hold the unaltered bytes
	shr ax, 2
	xchg al,ah					;more stupid endianness
	mov word [bx], ax

	;; somehow, mov the right two bits of cx into the left 2 bits of [bx]
	;; at first, these two bits will be the new dir.
	;; after the first loop, they will be the rightmost bits from the previous byte

	;; Possibly AND [bx], 00111111 (sets the left 2 bits to 0)
	;; Then shl cx, 6  (moves the right 2 bits to the left 2 bits)
	;; Then OR [bx], cx (sets the left 2 bits of cx to [bx]

	;; cant do AND between [bx] and 16 bit value
	push dx
	mov dx, word [bx]
	xchg dh, dl
	
	and dx, 0x3FFF		;doesn't work?
	shl cx, 6			;using cx as a queue
	or dx, cx

	xchg dh, dl
	mov word [bx], dx
	pop dx

	;; could cmp bx and remove dx entirely
	add dx, 8					;8 segments in 2 bytes
	add bx, 2					;ready for next 2 bytes

	cmp dx, [snake_sprite_length]
	jge snake_propagate_exit
	
	jmp snake_propagate_loop

snake_propagate_exit:
	;; add dir to first byte of snake
	and [snake_sprite], byte 0x3F
	mov cl, [snake_dir]
	shl cl, 6
	or [snake_sprite], cl
	;//inc word [snake_sprite_length]	;should do something if > max length
	popa
	ret


	;; 1 byte -> 4 segments of snake
	;; 00 - up
	;; 01 - down
	;; 10 - left
	;; 11 - right
snake_sprite:
	db 0x55
	db 0x55
	db 0x55		;dont forget about endianness
	times 512 db 0				;snake has a max length of 2048
snake_sprite_length:	dd 0x15

snake_sprite_head_pos:
	db 10						;y
	db 20						;x

snake_dir:	db 10b				;direction to propagate the snake

